function hc_demo()
% Demonstrace hierarchickho shlukovn

    close all;
    % Kolik je dat
    rng(2);
    num_data = 50;
    num_data_half = floor(num_data/2);
    % Generujeme 2D data (normln rozdlen)
    data = randn(num_data,2);
    figure(1);
    scatter(data(:,1),data(:,2));
    title('Pvodn data');
    % Upravme na dva shluky
    data(1:num_data_half,:) = data(1:num_data_half,:) + [3,-4];
    figure(2);
    scatter(data(:,1),data(:,2));
    title('Dva shluky');

    % V Matlabu pouvme na hierachick shlukovn postupn funkce
    %   pdist() ... prov vzdlenosr
    %   linkage()
    % ... cluster()
    
    % Naped urme Euklidovskou vzdlenost mezi vemi pry bod
    dist = pdist(data, 'euclid');
    % Najdeme hierarchick shluky minimalizac maximln vzdlenosti mezi
    % prvky shluku
    lnk_complete = linkage(dist, 'complete');
    % Nyn hierarchicky shlukneme na maximln poet `num_data` shluk
    cluster_complete = cluster(lnk_complete, 'maxclust', num_data);
    % Vykreslme pomoc `lnk_complete`
    figure(3);
    dendrogram(lnk_complete);

    % Najdeme hierarchick shluky minimalizac prmrn vzdlenosti mezi
    % prvky shluku
    lnk_average = linkage(dist, 'average');
    % Vykreslme pomoc `lnk_average`
    figure(4);
    dendrogram(lnk_average);

    % Nyn ozname 2 shluky v datech
    cluster2 = cluster(lnk_average, 'maxclust', 2);
    figure(5);
    scatter(data(:,1),data(:,2), 30, cluster2, 'filled');
    title('Hierarchick shlukovn, 2 shluky, average');
    
    % Nyn ozname 3 shluky v datech
    cluster3 = cluster(lnk_average, 'maxclust', 3);
    figure(6);
    scatter(data(:,1),data(:,2), 30, cluster3, 'filled');
    title('Hierarchick shlukovn,3 shluky, average');
    
    % Nyn ozname 4 shluky v datech
    cluster4 = cluster(lnk_average, 'maxclust', 4);
    figure(7);
    scatter(data(:,1),data(:,2), 30, cluster4, 'filled');
    title('Hierarchick shlukovn, 4 shluky, average');
    
    % Nyn ozname 7 shluky v datech
    cluster7 = cluster(lnk_average, 'maxclust', 7);
    figure(8);
    scatter(data(:,1),data(:,2), 30, cluster7, 'filled');
    title('Hierarchick shlukovn, 7 shluk, average');
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    

end

