function kmeans_demo()
% Demonstrace k-means shlukovn

    close all;
    % Kolik je dat
    rng(2);
    num_data = 50;
    num_data_half = floor(num_data/2);
    % Generujeme 2D data (normln rozdlen)
    data = randn(num_data,2);
    figure(1);
    scatter(data(:,1),data(:,2));
    title('Pvodn data');
    % Upravme na dva shluky
    data(1:num_data_half,:) = data(1:num_data_half,:) + [3,-4];
    figure(2);
    scatter(data(:,1),data(:,2));
    title('Dva shluky');
    % Vm, e mme dva shluky. Najdeme je pomoc kmeans()
    [km2, centroids2, withinss2] = kmeans(data, 2);
    % Vykreslme
    figure(3);
    scatter(data(:,1),data(:,2), 30, km2, 'filled');
    title('Obarven dva shluky');
    % Celkov souet rozptylu mezi body shluk
    tot2 = sum(withinss2);
    % Co kdy jsou shluky 3?
    [km3, centroids3, withinss3] = kmeans(data, 3);
    % Vykreslme
    figure(4);
    scatter(data(:,1),data(:,2), 30, km3, 'filled');
    hold on;
    plot(centroids3(:,1),centroids3(:,2),'r*');
    title('Obarven ti shluky');
    %
    % centroids2
    % withinss2
    %
    % centroids3
    % withinss3
    %
    % Celkov souet rozptylu mezi body shluk
    tot3 = sum(withinss3);
    % Identifikujeme 3 optimln shluky po 50 restartech
    [km3b, centroids3b, withinss3b] = kmeans(data, 3, 'Replicates', 50);
    % Vykreslme
    figure(5);
    scatter(data(:,1),data(:,2), 30, km3b, 'filled');
    hold on;
    plot(centroids3b(:,1),centroids3b(:,2),'r*');
    title('Obarven ti optimln shluky');
    % Celkov souet rozptylu mezi body shluk
    tot3b = sum(withinss3b);
    tot2, tot3, tot3b
    
    %%
    % Identifikujeme 3 optimln shluky po 50 restartech
    [km3c, centroids3c, withinss3c] = kmeans(data, 3, 'Replicates', 50, 'Distance', 'cityblock');
    % Vykreslme
    figure(6);
    scatter(data(:,1),data(:,2), 30, km3c, 'filled');
    hold on;
    plot(centroids3c(:,1),centroids3c(:,2),'r*');
    title('Obarven ti optimln shluky, cityblock');
    tot3c = sum(withinss3c);
    tot2, tot3, tot3b, tot3c
    
    
    
    
    
    
    
    

end

